package org.lsst.gruth.grutils

/**
 *  Generated by assertion methods. Gru assertions do not fail at once when evaluated:
 *  <TT>AssertionReport</TT> keeps the result of an assertion evaluation: the test
 *  overall result is the "worst" contained in all AssertionReports
 *  (see RawDiagnostic order to evaluate Result order).
 *  <P>
 *   There is an exception to this rule: if the <TT>force</TT> boolean is used
 *   the result of the test is forced to the first "forced" assertion
 *   (this happens for example when an exception is fired: the test result may be temporarily failed
 *   but if the exception is expected the assertion forces to SUCCESS).
 *
 * @author bamade
 * 
 */
class AssertionReport implements Serializable{
    String message ;
    RawDiagnostic result ;
    boolean force = false

    AssertionReport(String message, RawDiagnostic result) {
        this.message = message
        this.result = result
    }
    AssertionReport(boolean force ,String message, RawDiagnostic result) {
        this.force = force
        this.message = message
        this.result = result
    }

    String toString() {
       "assert: ${message} -> ${result}"
    }
}
