package org.lsst.gruth.grutils

/**
 * A <TT>GrouSpec</TT> that specifies tests that build objects (constructor; static factories)
 * @author bamade
 * 
 */
class BuildGroupSpec extends GroupSpec  {
    BuildGroupSpec(String className , Binding bind){
        super(SpecType.CTOR, bind, className )
    }

    /**
    * calls the other _group method by generating a name for the group
    * @param clos
    * @return
    */
    GroupRun _group( Closure clos) {
          int number = _this.groupNumber
        String name = "#group${number}"
        _this.groupNumber = number+1
        return _group(name, clos)

    }

    /**
    *  prepares a set of test (GroupRun) (for constructors only for the moment)
    * @param name
    * @param clos
    * @return
    */
    GroupRun _group(String name, Closure clos) {
        //sets up the type except if Factory
        if(null != this.specType) {
            //this.specType = SpecType.CTOR
            this.groupName = name
            this.reportTemplate.methodName = '<ctor>'
             MetaClass meta = clazz.metaClass
             this.execCode = meta.&invokeConstructor
        }
        try {
            clos.setDelegate(this)
            clos.setBinding(_this)
            _this.currentGroup = this
            // gathers the requested tests
             clos.call()
            _this.currentGroup = null
        } catch (Throwable err) {
            this.reportTemplate.caught<<err
            this.reportTemplate.rawDiagnostic = RawDiagnostic.TOOL_OR_CODE_ERROR
        }
        //println 'reportTemplate:' + this.reportTemplate+ ' execCode ' + execCode

         return this._prepare()
    }

    /**
     * NOT IMPLEMENTED: specification of test for a static factory
     * @param factoryName
     * @return
     */
    // TODO: implement _factory
    BuildGroupSpec _factory (String factoryName) {
        throw new UnsupportedOperationException("no factory yet")
        // TODO: override spectype
        if( null != this.specType) {
            //generates an error but lets the tests build run
        } else {
            this.specType = SpecType.STATIC_FACTORY
            this.reportTemplate.methodName = factoryName

        }

    }

    // TODO: write static method call (will retrun a different type MethodCallRBatchSpec ?
    // _method(String groupName)
}
