package org.lsst.gruth.grutils

/**
 * A <TT>TaggedsMap</TT> that flattens every build argument.
 * This is used to build a TaggedsMap from a list of values but List and Map are not kept "as is".
 * @author bamade
 */
 // Date: 26/07/12
 
class FlatMap extends TaggedsMap {
    public FlatMap(Object... args){
        super()
        for(Object obj : args) {
            if(obj instanceof Map) {
                this << obj as Map
            } else if (obj instanceof List) {
                this << obj as List
            } else {
                this << obj
            }
        }
    }
}
