package org.lsst.gruth.grutils

import org.lsst.gruth.jutils.NumberedStringGenerator

/**
 * stores <TT>TztReport</TT> objects in a file: these objects are in fact encapsulated in
 *  serialized <TT>AnnotatedReport</TT> objects.
 * @author bamade
 */
// Date: 29/08/12

class ObjectFileResultReporter extends ResultReporter {
    Map<String, ObjectOutputStream> ooStreams = new HashMap<String, ObjectOutputStream>();
    ObjectOutputStream currentStream;
    //TO be changed
    File dir = new File('.')

    @Override
    def report(AnnotatedReport report) {
        currentStream.writeObject(report)
        currentStream.flush()
    }

    @Override
    def begin() {
        return null
    }

    @Override
    def end() {
        return null
    }

    @Override
    def groupReportsUnderName(String name) {
        //gets from the Map
        ObjectOutputStream oos = ooStreams.get(name)
      if(oos == null) {
          oos =createStreamFromName(name)
          ooStreams.put(name, oos)
      }
        // or create a new one by numbering
        currentStream =oos
        return oos
    }

    ObjectOutputStream createStreamFromName(String name) {
        //TODO: change with modified dir variable
        String fileNamePattern = name+'#.rawres'
        NumberedStringGenerator generator = new NumberedStringGenerator(fileNamePattern)
        for (String fileName: dir.list()) {
            generator.submit(fileName)
        }
        String newName = generator.getNewString()
        OutputStream os = new FileOutputStream(newName)
        ObjectOutputStream oos = new ObjectOutputStream(new BufferedOutputStream(os))
        return oos

    }

    void close() {
        for (ObjectOutputStream oos : ooStreams.values()) {
            oos.close();
        }
    }
}
