package org.lsst.gruth.grutils

/**
 * this data is created by _test method and modified
 * by its own methods.
 * It does not represent a test because the <TT>rawArgs</TT> field
 * may represent combinations of parameters for a constructor, factory, or method call.
 */
class RawTestSpec {
    // of the form TESTA: arg1,arg2, arg3 TESTB: arg3,arg4,arg5
    // each arg could be an instance or a set (TaggedsMap)
    Map rawArgs ;
    /**
     * code to be run before executing this specific test.
     */
    Closure setUp;
    /**
     * code to be run after executing this specific test.
     */
    Closure tearDown;
    /**
     * code to be run after executing this specific test
     * and before tearDown. It should test expectations.
     */
    Closure expectations ;
    /**
     * Code to be executed before each test run in this combination of test
     * described by _test method.
     *
     * @param clos
     * @return
     */
    RawTestSpec _pre(Closure clos) {
        setUp = clos
        return this
    }

    /**
     * Code to be executed after each test run in this combination of test
     * described by _test method.
     *
     * @param clos
     * @return
     */
    RawTestSpec _post(Closure clos) {
        tearDown = clos
        return this
    }

    /**
     * code that analyses the properties of the calls described by the _test method.
     *  This code may  describe assertions that will modify the result of each test
     *
     * @param clos
     * @return
     */
    RawTestSpec _xpect(Closure clos) {
        expectations = clos
        return this
    }


}
