package org.lsst.gruth.grutils

import java.util.logging.Level

/**
 *
 * @author bamade
 *
 */
class SimpleResultFormatter implements ResultFormatter {

    String pre(AnnotatedReport report) {
        return ""
    }

    static final boolean TRACE = false;

    String body(AnnotatedReport aReport) {
        TztReport report = aReport.getReport()
        if (TRACE) {
            report.caught.each {
                Cst._LOGGER.log(Level.WARNING, "", it)
            }
        }
        Object supporting;
        if(report.supportingObject instanceof TaggedObject) {
            supporting = ((TaggedObject)report.supportingObject).key
        } else {
            supporting = report.supportingObject
        }
        // suppressed advice: ${report.advice ?: ''}
        String res = """
    ${aReport.modification? aReport.modification: ''}
    ${aReport.advice? aReport.advice: ''}
    ##result
        testName: $report.testName
        rawDiagnostic: $report.rawDiagnostic
        methodName: $report.methodName
        className: $report.className
        ${supporting ? "supportingObject: $supporting" : ''}
        ${report.data ? "data: $report.data" : ''}
        ${report.additionalData ? "additionalData: $report.additionalData" : ''}

    #messages-----------------------------------
         $report.messages
    #end----------------------------------------

    #assertions-----------------------------------
         $report.listAssertions
    #end----------------------------------------

    #caughts-----------------------------------
         $report.caught
    #end----------------------------------------
    ##end

    """
        if(aReport.neededPreviousReport != null) {
            res = res + '\n################## PREVIOUS REPORT ' +
                    body(aReport.neededPreviousReport) + '\n################# END PREVIOUS REPORT'
        }
        return res
    }

    String post(AnnotatedReport report) {
        return ""
    }
}
