package org.lsst.gruth.nodes

import org.lsst.gruth.jutils.MapArgs
import java.lang.reflect.Array
import org.lsst.gruth.jutils.BuiltParm

/**
 *
 * @author bamade
 *
 */
class NodeUtils {


    public static Object[] loop(int nb, Closure clos) {
        return loop( new IntRange(0,nb-1), clos)
    }


    public static Object[] loop(List list, Closure clos) {
        def resBase = []
        list.each {
            //clos.delegate = it
            resBase += clos.call(it)
        }
        Object first = resBase.get(0);
        if (first != null) {
            if (first instanceof Map.Entry) {
                Class clazz = first.getClass();
                return resBase.toArray((Object[]) Array.newInstance(clazz, 0));
            }
        }
        return resBase.toArray();
    }


    public static BuiltParm loopList(int nb, Closure clos) {
        return BuiltParm.bldList(loop(nb, clos));
    }

    public static BuiltParm loopMap(int nb, Closure clos) {
        return BuiltParm.bldMap((MapArgs.LEntry[]) loop(nb, clos));
    }
    public static BuiltParm loopArray(int nb, Closure clos) {
        return BuiltParm.bldArray((MapArgs.LEntry[]) loop(nb, clos));
    }

    public static BuiltParm loopList(List list, Closure clos) {
        return BuiltParm.bldList(loop(list, clos));
    }

    public static BuiltParm loopMap(List list, Closure clos) {
        return BuiltParm.bldMap((MapArgs.LEntry[]) loop(list, clos));
    }
    public static BuiltParm loopArray(List list, Closure clos) {
        return BuiltParm.bldArray((MapArgs.LEntry[]) loop(list, clos));
    }

}
