package org.lsst.gruth.nodes;

import groovy.lang.Closure;
import groovy.util.BuilderSupport;
import org.lsst.gruth.jutils.CallBuilders;
import org.lsst.gruth.jutils.ComponentNode;

import java.util.Map;

/**
 * though this looks much like <TT>ObjectGraphBuilder</TT>
 * we have slightly different constraints.
 *
 * @author bamade
 */
public class ComponentBuilder extends BuilderSupport {

    static {
        CallBuilders.setCallBuilder(new CallBuilders.CallBuilds() {
            @Override
            public ComponentNode buildCalls(ComponentNode node, Object  obj) {
                if (obj instanceof Closure) {
                    //System.out.println("-----------> invoking calls");
                    Closure closure = (Closure) obj;
                    MethodCallsBuilder builder = new MethodCallsBuilder(node, closure);
                    //Object res = builder.invokeMethod("__calls__", closure);
                    //this.append((Node) res) ;
                    return builder.getCalls();
                }
                return null;
            }
        });
    }

    /*
     public static NodeBuilder newInstance() {
       return new NodeBuilder();
   }

    */
    @Override
    public void setParent(Object o, Object o1) {
        ComponentNode parent = (ComponentNode) o;
        //System.out.println("set parent :" + parent.getName() + " <- " + ((ComponentNode) o1).getName());
        parent.addChild((ComponentNode) o1);
    }

    @Override
    public Object createNode(Object name) {
        //return new ComponentNode(getCurrentNode(), name, new ArrayList());
        //System.out.println("createNode : parent :" + thisName() + "<- " +name);
        return new ComponentNode(getCurrentNode(), name);
    }

    @Override
    public Object createNode(Object name, Object value) {
        //System.out.println("createNode : parent :" + thisName() + "<- " +name +" value:" + value);
        return new ComponentNode(getCurrentNode(), name, value);
    }

    @Override
    public Object createNode(Object name, Map attributes) {
        //return new ComponentNode(getCurrentNode(), name, attributes, new ArrayList());
        //System.out.println("createNode : parent :" + thisName() + "<- " +name +" attributes:" + attributes);
        return new ComponentNode(getCurrentNode(), name, attributes);
    }

    @Override
    public Object createNode(Object name, Map attributes, Object value) {
        /*
        System.out.println("createNode : parent :" + thisName() + "<- " +name
               + " value:" + value
                +" attributes:" + attributes);
          */
        return new ComponentNode(getCurrentNode(), name, attributes, value);
    }

    protected ComponentNode getCurrentNode() {
        ComponentNode current =  (ComponentNode) getCurrent();
        //System.out.println("current node " + (current!= null?current.getName(): "null"));
        return current ;
    }

    private String thisName() {
        ComponentNode curNode = getCurrentNode();
        if (curNode != null) {
            return curNode.getName();
        }
        return "null";
    }

}
