package org.lsst.gruth.nodes;

import groovy.lang.Binding;
import groovy.lang.GroovyShell;
import org.lsst.gruth.jutils.ComponentNode;

import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * @author bamade
 */
// Date: 04/06/12

public class Utils {
    /**
     * generates a Component node from a simple script.
     * The ComponentBuilder is named <TT>builder</TT> and is provided in the Binding.
     * @param inputStream
     * @param encoding specifies the text encoding
     * @return
     * @throws Exception
     */
    public static ComponentNode getComponentNodeFromGroovy(InputStream inputStream, String encoding) throws Exception{
        GroovyShell shell = shellFactory() ;
        InputStreamReader reader = new InputStreamReader(inputStream,encoding) ;
        Object res = shell.evaluate(reader) ;
        if(! (res instanceof ComponentNode)) {
            throw new IllegalArgumentException(" described object not a ComponentNode but " +res.getClass());
        }
        return (ComponentNode) res;
    }

    static GroovyShell shellFactory() {
        Binding binding = new Binding() ;
        ComponentBuilder builder = new ComponentBuilder() ;
        binding.setProperty("builder", builder) ;
       // ClassLoader loader = Thread.currentThread().getContextClassLoader();
        //GroovyClassLoader groovyLoader = new GroovyClassLoader(loader) ;
        //GroovyShell shell = new GroovyShell(groovyLoader, binding) ;
        GroovyShell shell = new GroovyShell(binding) ;
       return shell ;
    }

    public static ComponentNode getComponentNodeFromGroovy(String scriptString) {
        GroovyShell shell = shellFactory() ;
        Object res = shell.evaluate(scriptString) ;
        if(! (res instanceof ComponentNode)) {
            throw new IllegalArgumentException("described object not a ComponentNode but " +res.getClass());
        }
        return (ComponentNode) res;

    }
}
